/*
  Firmware for Bitmap Projector
  Copyright (C) 2011 Matt Evans

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Basic serial IO
*/

#ifndef SERIO_H
#define SERIO_H

#include "hw.h"
#include <inttypes.h>
#include <avr/io.h>

#define PS(x) printstr_p(PSTR(x))

void serial_init(void);

uint8_t rxWaiting(void);
void putchr(char c);
char getchr(void);

void pnewl();

void printstr(const char *str);
void printstr_p(const char *str);

void phex8(uint8_t n);
void phex16(uint16_t n);
void phex32(uint32_t n);

uint8_t  ghex8(unsigned char *errPtr);
uint16_t ghex16(unsigned char *errPtr);
uint32_t ghex32(unsigned char *errPtr);

#endif
